# Interfaces

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://rafaqz.github.io/Interfaces.jl/stable/)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://rafaqz.github.io/Interfaces.jl/dev/)
[![Build Status](https://github.com/rafaqz/Interfaces.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/rafaqz/Interfaces.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/rafaqz/Interfaces.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/rafaqz/Interfaces.jl)

Macros for defining the required behaviours of Julia interfaces,
and stating that an object implements them.

The goal is to get as much as possible out of defining an interface,
specifically:

- Traits: All `@implements` declarations produce compile-time traits that can be
  checked by other packages - for the whole interface and all of it's optional
  components.
- Tests: `@implements` declarations should be tested in package tests.
- Docs: interface documentation can be inserted into trait documentation.

See the `IterationInterface` in BaseInterfaces.jl (a subpackage of this package) or the documentation
for examples of `@interface` and `@implements`.

__Note: the syntax here is likely to change as we work out the best ways to define interfaces__

If you think it should behave differently or there is better syntax,
please make an issue.

# BaseInterfaces

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://rafaqz.github.io/Interfaces.jl/stable/)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://rafaqz.github.io/Interfaces.jl/dev/)
[![Build Status](https://github.com/rafaqz/Interfaces.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/rafaqz/Interfaces.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/rafaqz/Interfaces.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/rafaqz/Interfaces.jl)

BaseInterfaces.jl is a subpackage of Interfaces.jl that provides predifined 
definition and testing for Base Julia interfaces.

Currently this includes:
- A general iteration interface: `IterationInterface`
- `AbstractArray` interface: `ArrayInterface`
- `AbstractSet` interface: `SetInterface`
- `AbstractDict` interface: `DictInterface`


Testing your object follows the interfaces is as simple as:

```julia
using BaseInterfaces, Interfaces
Interfaces.tests(DictInterface, MyDict, [mydict1, mydict2, ...])
```

Declaring that it follows the interface is done with:

```julia
@implements DictInterface{(:component1, :component2)} MyDict
```

Where components can be chosen from `Interfaces.optional_keys(DictInterface)`.

See [the docs](https://rafaqz.github.io/Interfaces.jl/stable/) for use.

If you want to add more Base julia interfaces here, or think the existing 
ones could be improved, please make an issue or pull request.

function _help_header(@nospecialize(interface::Type{<:Interface}))
    m_keys = mandatory_keys(interface)
    o_keys = optional_keys(interface)
    return "An Interfaces.jl `Interface` with mandatory components `$m_keys` and optional components `$o_keys`."
end

function _extended_help(@nospecialize(interface::Type{<:Interface}))
    comp = components(interface)

    io_buf = IOBuffer()
    # ^(More efficient and readable than string concatenation)

    println(io_buf, "# Extended help")
    !isempty(comp.mandatory) && println(io_buf, "\n## Mandatory keys:\n")
    _list_keys(io_buf, comp.mandatory)

    !isempty(comp.optional) && println(io_buf, "\n## Optional keys:\n")
    _list_keys(io_buf, comp.optional)

    return String(take!(io_buf))
end

function _list_keys(io::IO, @nospecialize(component))
    for key in keys(component)
        print(io, "* `$key`")
        values = component[key]
        if values isa Tuple && all(Base.Fix2(isa, Pair), values)
            # Such as `iterate = ("description1" => f, "description2" => g)`
            println(io, ":")
            for value in values
                println(io, "  * $(first(value))")
            end
        elseif values isa Pair
            # Such as `iterate = "description" => f`
            println(io, ": $(first(values))")
        else
            # all other cases, like `iterate = f`
            println(io)
        end
    end
    return nothing
end

# TODO add grouping to reduce the number of options
@implements SetInterface{(:copy,:empty,:emptymutable,:hasfastin,:setdiff,:intersect,:union,:empty!,:delete!,:push!,:copymutable,:sizehint!)} Set [Set((1, 2))]
@implements SetInterface{(:copy,:empty,:emptymutable,:hasfastin,:setdiff,:intersect,:union,:empty!,:delete!,:push!,:copymutable,:sizehint!)} BitSet [BitSet((1, 2))]
@implements SetInterface{(:empty,:emptymutable,:hasfastin,:intersect,:union,:sizehint!)} Base.KeySet [Base.KeySet(Dict(:a=>1, :b=>2))]
@implements SetInterface{(:empty,:hasfastin,:intersect,:union,:sizehint!)} Base.IdSet (s = Base.IdSet(); push!(s, "a"); push!(s, "b"); [s])

# # Basic

# Here's an example of single-argument interface using animals, and the implementation of a duck.

# ## Definition

#=
First we define the interface methods, and a list of mandatory and
optional properties of the interface, with conditions, using the `@interface`
macro.

The `@interface` macro takes three arguments:
1. The name of the interface, which should usully end with "Interface"
2. The `mandatory` and `optional` components of the interface written as a `NamedTuple`, with functions or tuple of functions that test them.
3. The interface docstring (the interface is represented as a type)
=#

module Animals

using Interfaces

abstract type Animal end

function age end
function walk end
function talk end
function dig end

components = (
    mandatory = (
        age = (
            "all animals have a `Real` age" => x -> age(x) isa Real,
            "all animals have an age larger than zero" => x -> age(x) >= 0,
        ),
    ),
    optional = (
        walk = "this animal can walk" => x -> walk(x) isa String,
        talk = "this animal can talk" => x -> talk(x) isa Symbol,
        dig = "this animal can dig" => x -> dig(x) isa String,
    )
)

description = """
Defines a generic interface for animals to do the things they do best.
"""

@interface AnimalInterface Animal components description

end;

# ## Implementation

using Interfaces, Test

# Now we implement the `AnimalInterface`, for a `Duck`.

struct Duck <: Animals.Animal
    age::Int
end

Animals.age(duck::Duck) = duck.age
Animals.walk(::Duck) = "waddle"
Animals.talk(::Duck) = :quack

# We then test that the interface is correctly implemented

ducks = [Duck(1), Duck(2)]
Interfaces.test(Animals.AnimalInterface, Duck, ducks)

# As well as two optional methods

Interfaces.test(Animals.AnimalInterface{(:walk,:talk)}, Duck, ducks)

#=
Finally we declare it, so that the information can be used in static dispatch.

The `@implements` macro takes two arguments.
1. The interface type, with a tuple of optional components in its first type parameter. 
2. The type for which the interface is implemented.
=#

@implements Animals.AnimalInterface{(:walk,:talk)} Duck [Duck(1), Duck(2)]

# Now let's see what happens when the interface is not correctly implemented.
struct Chicken <: Animals.Animal end

# As expected, the tests fail
chickens = [Chicken()]
try
    Interfaces.test(Animals.AnimalInterface, Chicken, chickens)
catch e
    print(e)
end

# The following tests are not included in the docs  #src

using Test  #src

@testset "Duck" begin  #src
    @test Interfaces.implements(Animals.AnimalInterface, Duck) == true  #src
    @test Interfaces.implements(Animals.AnimalInterface{:dig}, Duck) == false  #src
    @test Interfaces.test(Animals.AnimalInterface, Duck) == true  #src
    @test Interfaces.test(Animals.AnimalInterface{(:walk,:talk)}, Duck) == true  #src
    @test Interfaces.test(Duck) == true # Test all implemented interfaces for Duck
    @test Interfaces.test(Animals.AnimalInterface) == true # Test all implemented types for AnimalInterface
    # TODO wrap errors somehow, or just let Invariants.jl handle that.  #src
    @test_throws Interfaces.InterfaceError Interfaces.test(Animals.AnimalInterface{:dig}, Duck)  #src
end  #src

@testset "Chicken" begin  #src
    @test Interfaces.implements(Animals.AnimalInterface{(:walk,:talk)}, Chicken()) == false  #src
    @test_throws Interfaces.InterfaceError Interfaces.test(Animals.AnimalInterface{(:walk,:talk)}, Chicken())  #src
end  #src

@implements IterationInterface{(:reverse,:indexing)} UnitRange [1:5, -2:2]
@implements IterationInterface{(:reverse,:indexing)} StepRange [1:2:10, 20:-10:-20]
@implements IterationInterface{(:reverse,:indexing)} Array [[1, 2, 3, 4], [:a :b; :c :d]]
@implements IterationInterface{(:reverse,:indexing)} Tuple [(1, 2, 3, 4)]
@static if VERSION >= v"1.9.0"
    @implements IterationInterface{(:reverse,:indexing)} NamedTuple [(a=1, b=2, c=3, d=4)]
else
    @implements IterationInterface{:indexing} NamedTuple [(a=1, b=2, c=3, d=4)] # No reverse on 1.6
end
@implements IterationInterface{(:reverse,:indexing)} String ["abcdefg"]
@implements IterationInterface{(:reverse,:indexing)} Pair [:a => 2]
@implements IterationInterface Number [1, 1.0, 1.0f0, UInt(8), false]
@implements IterationInterface{:reverse} Base.Generator [(i for i in 1:5), (i for i in 1:5)]
# @implements IterationInterface{(:reverse,:indexing)} Base.EachLine [eachline(joinpath(dirname(pathof(BaseInterfaces)), "implementations.jl"))]

@implements IterationInterface Set [Set((1, 2, 3, 4))]
@implements IterationInterface BitSet [BitSet((1, 2, 3, 4))]
@implements IterationInterface Dict [Dict("a" => 2, :b => 3.0)]
@implements IterationInterface Base.EnvDict [Arguments(d=Base.EnvDict())]
@implements IterationInterface Base.ImmutableDict [Arguments(d=Base.ImmutableDict(:a => 1, :b => 2))]
# @implements IterationInterface IdDict
# @implements IterationInterface WeakKeyDict

# Should iteration be here?

mandatory = (;
    isempty = !isempty,
)

optional = (; 
    empty! = c -> isempty(empty!(c)),
    length = c -> length(c) isa Integer,
    # push! = 
    # pushfirst! = 
    # deleteat! = 
    # splice! = 
    # pop! = 
    # popfirst! = 
)

components = (; mandatory, optional)

@interface CollectionInterface Any _components "Base interface for shared methods of various collections"

expected_extended_help = """# Extended help

## Mandatory keys:

* `neutral_check`:
  * neutral stable
* `multiplication_check`:
  * multiplication stable
* `inversion_check`:
  * inversion stable
  * inversion works"""

@test strip(Interfaces._extended_help(Group.GroupInterface)) == strip(expected_extended_help)


expected_docs = """```
    GroupInterface
```

An Interfaces.jl `Interface` with mandatory components `(:neutral_check, :multiplication_check, :inversion_check)` and optional components `()`.

A group is a set of elements with a neutral element where you can perform multiplications and inversions.

The conditions checking the interface accept an `Arguments` object with two fields named `x` and `y`. The type of the first field `x` must be the type you wish to declare as implementing `GroupInterface`.

# Extended help

## Mandatory keys:

  * `neutral_check`:

      * neutral stable
  * `multiplication_check`:

      * multiplication stable
  * `inversion_check`:

      * inversion stable
      * inversion works"""

@test strip(string(@doc Group.GroupInterface)) == strip(expected_docs)

# Some example interface delarations.

# @implements ArrayInterface Base.LogicalIndex # No getindex

@implements ArrayInterface{:logical} UnitRange [2:10]
@implements ArrayInterface{:logical} StepRange [2:1:10]
@implements ArrayInterface{:logical} Base.OneTo [Base.OneTo(10)]

# @implements ArrayInterface Base.Slice [Base.Slice(100:150)]
# These are breaking unreliably in CI. No idea how this can work sometimes and not others...
#
# Testing ArrayInterface is implemented for Base.IdentityUnitRange
# InterfaceError: test for ArrayInterface :getindex 19 "Can index with a Vector of Int32" threw a BoundsError 
#  For test object Base.IdentityUnitRange(100:150):

# Error During Test at /home/runner/work/Interfaces.jl/Interfaces.jl/BaseInterfaces/test/runtests.jl:10
#   Test threw exception
#   Expression: Interfaces.test()
#   BoundsError: attempt to access 51-element Base.IdentityUnitRange{UnitRange{Int64}} with indices 100:150 at index [100]
#   Stacktrace:
# @implements ArrayInterface Base.IdentityUnitRange [Base.IdentityUnitRange(100:150)]
@implements ArrayInterface{:logical} Base.CodeUnits [codeunits("abcde")]
@implements ArrayInterface{(:logical,:setindex!,:similar_type,:similar_eltype,:similar_size)} Array [[3, 2], ['a' 'b'; 'n' 'm']]
@implements ArrayInterface{(:logical,:setindex!,:similar_type,:similar_size)} BitArray [BitArray([false true; true false])]
@implements ArrayInterface{(:logical,:setindex!)} SubArray [view([7, 2], 1:2)]
@implements ArrayInterface{(:logical,:setindex!)} PermutedDimsArray [PermutedDimsArray([7 2], (2, 1))]
@implements ArrayInterface{(:logical,:setindex!)} Base.ReshapedArray [reshape(view([7, 2], 1:2), 2, 1)]

@implements DictInterface{:setindex!} Dict [Arguments(d=Dict(:a => 1, :b => 2), k=:c, v=3)]
@implements DictInterface{:setindex!} IdDict [Arguments(d=IdDict(:a => 1, :b => 2), k=:c, v=3)]
# This errors because the ref is garbage collected
# @implements DictInterface{:setindex!} WeakKeyDict [Arguments(; d=WeakKeyDict(Ref(1) => 1, Ref(2) => 2), k=Ref(3), v=3)]
@implements DictInterface Base.EnvDict [Arguments(d=Base.EnvDict())]
@implements DictInterface Base.ImmutableDict [Arguments(d=Base.ImmutableDict(:a => 1, :b => 2))]
@static if VERSION >= v"1.9.0"
    @implements DictInterface Base.Pairs [Arguments(d=Base.pairs((a = 1, b = 2)))]
end

using Documenter
using Interfaces
using BaseInterfaces
using Literate

DocMeta.setdocmeta!(Interfaces, :DocTestSetup, :(using Interfaces); recursive=true)

# Copy README
base_url = "https://github.com/rafaqz/Interfaces.jl/blob/main/"
index_path = joinpath(@__DIR__, "src", "index.md")
readme_path = joinpath(dirname(@__DIR__), "README.md")

open(index_path, "w") do io
    println(
        io,
        """
        ```@meta
        EditURL = "$(base_url)README.md"
        ```
        """,
    )
    for line in eachline(readme_path)
        println(io, line)
    end
end

# Copy test files
Literate.markdown(
    joinpath(dirname(@__DIR__), "test", "basic.jl"),
    joinpath(@__DIR__, "src")
)
Literate.markdown(
    joinpath(dirname(@__DIR__), "test", "advanced.jl"),
    joinpath(@__DIR__, "src")
)

makedocs(;
    modules=[Interfaces, BaseInterfaces],
    authors="Rafael Schouten <rafaelschouten@gmail.com>",
    sitename="Interfaces.jl",
    format=Documenter.HTML(;
        repolink="https://github.com/rafaqz/Interfaces.jl",
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://rafaqz.github.io/Interfaces.jl",
        edit_link="main",
    ),
    pages=[
        "Home" => "index.md",
        "Examples" => ["Basic" => "basic.md", "Advanced" => "advanced.md"],
        "API reference" => "api.md",
        "BaseInterfaces.jl reference" => "baseinterfaces.md",
    ],
)

deploydocs(;
    repo="github.com/rafaqz/Interfaces.jl",
    devbranch="main",
    push_preview=true
)

"""
    Interfaces

A Julia package for specifying and testing interfaces (conditions verified by a set of methods applied to a type).
"""
module Interfaces

export Arguments
export @implements, @interface

include("arguments.jl")
include("interface.jl")
include("documentation.jl")
include("implements.jl")
include("test.jl")

end

using Interfaces
using Interfaces: first_field_type
using Test

ks = (:x, :y, :z)
vs = (1, 2.0, "3")

a = Arguments(x = 1, y = 2.0, z = "3")

a2 = Arguments{ks}(vs)
@test a == a2

@test keys(a) == (:x, :y, :z)
@test values(a) == (1, 2.0, "3")
@test length(a) == 3
@test collect(a) == [1, 2.0, "3"]

@test haskey(a, :x)
@test haskey(a, 1)
@test !haskey(a, :w)
@test !haskey(a, 4)

@test a.x == 1
@test a[:x] == 1
@test a[1] == 1
@test a[:] == a

@test first_field_type(typeof(a)) == Int

#= Abstract Arrays
https://docs.julialang.org/en/v1/manual/interfaces/

Methods to implement		            Brief description
size(A)		                            Returns a tuple containing the dimensions of A
getindex(A, i::Int)		                (if IndexLinear) Linear scalar indexing
getindex(A, I::Vararg{Int, N})          (if IndexCartesian, where N = ndims(A)) N-dimensional scalar indexing

Optional methods	                    Default definition	                    Brief description
IndexStyle(::Type)	                    IndexCartesian()	                    Returns either IndexLinear() or IndexCartesian(). See the description below.
setindex!(A, v, i::Int)		                                                    (if IndexLinear) Scalar indexed assignment
setindex!(A, v, I::Vararg{Int, N})                                              (if IndexCartesian, where N = ndims(A)) N-dimensional scalar indexed assignment
getindex(A, I...)	                    defined in terms of scalar getindex	    Multidimensional and nonscalar indexing
setindex!(A, X, I...)	                defined in terms of scalar setindex!	Multidimensional and nonscalar indexed assignment
iterate	                                defined in terms of scalar getindex	Iteration
length(A)	                            prod(size(A))	                        Number of elements
similar(A)	                            similar(A, eltype(A), size(A))	        Return a mutable array with the same shape and element type
similar(A, ::Type{S})	                similar(A, S, size(A))	                Return a mutable array with the same shape and the specified element type
similar(A, dims::Dims)	                similar(A, eltype(A), dims)	            Return a mutable array with the same element type and size dims
similar(A, ::Type{S}, dims::Dims)	    Array{S}(undef, dims)	                Return a mutable array with the specified element type and size

Non-traditional indices	                Default definition	                    Brief description
axes(A)	                                map(OneTo, size(A))	                    Return a tuple of AbstractUnitRange{<:Integer} of valid indices
similar(A, ::Type{S}, inds)	            similar(A, S, Base.to_shape(inds))	    Return a mutable array with the specified indices inds (see below)
similar(T::Union{Type,Function}, inds)	T(Base.to_shape(inds))	                Return an array similar to T with the specified indices inds (see below)
=#

# And arbitrary new type for array values
struct ArrayTestVal
    a::Int
end

# In case `eltype` and `ndims` have custom methods
# We should always be able to use these to mean the same thing
_eltype(::AbstractArray{T}) where T = T
_ndims(::AbstractArray{<:Any,N}) where N = N

array_components = (;
    mandatory = (;
        eltype = (
            A -> eltype(A) isa Type,
            A -> eltype(A) == _eltype(A),
            # Everything else is tested later
        ),
        ndims = (
            A -> ndims(A) isa Int,
            A -> ndims(A) == _ndims(A),
            # Everything else is tested later
        ),
        size = (
            "size(A) returns a tuple of Integer" => A -> size(A) isa NTuple{<:Any,Integer},
            "length of size(A) matches ndims(A)" => A -> length(size(A)) == ndims(A),
        ),
        getindex = (
           "Can index with begin/firstindex" => A -> A[begin] isa eltype(A),
           "Can index with end/lastindex" => A -> A[end] isa eltype(A),
           "Can index with all indices in `eachindex(A)`" => A -> all(x -> A[x] isa eltype(A), eachindex(A)),
           "Can index with Int for multiple dimensions" => A -> A[map(first, axes(A))...] isa eltype(A),
           "Can index with Int for multiple dimensions and trailing ones" => A -> A[map(first, axes(A))..., 1, 1, 1] isa eltype(A),
           "Can index with Int for multiple dimensions and trailing colons" => A -> size(A[map(first, axes(A))..., :, :, :]) == (1, 1, 1),
           "Can index with CartesianIndex" => 
               A -> A[CartesianIndex(map(first, axes(A))...)] isa eltype(A),
           "Can index with CartesianIndex and trailing ones" => 
               A -> A[CartesianIndex(map(first, axes(A))...), 1, 1, 1] isa eltype(A),
           "Can index with CartesianIndices" => 
               A -> size(A[CartesianIndices(map(a -> first(a):last(a), axes(A)))]) == size(A),
           "Can index with CartesianIndices and trailing ones" => 
               A -> size(A[CartesianIndices(map(a -> first(a):last(a), axes(A))), 1, 1, 1]) == size(A),
           "Can index with CartesianIndices and trailing colons" => 
               A -> size(A[CartesianIndices(map(a -> first(a):last(a), axes(A))), :, :, :]) == (size(A)..., 1, 1, 1),
           "Can index with UnitRange" => 
               A -> size(A[map(a -> first(a):last(a), axes(A))...]) == size(A),
           "Can index with UnitRange and trailing ones" => 
               A -> size(A[map(a -> first(a):last(a), axes(A))..., 1, 1, 1]) == size(A),
           "Can index with UnitRange and trailing colons" => 
               A -> size(A[map(a -> first(a):last(a), axes(A))..., :, :, :]) == (size(A)..., 1, 1, 1),
           "Can index with StepRange" => 
               A -> size(A[map(a -> first(a):2:last(a), axes(A))...]) == map(a -> length(first(a):2:last(a)), axes(A)),
           "Can index with StepRange and trailing ones" => 
               A -> size(A[map(a -> first(a):2:last(a), axes(A))..., 1, 1, 1]) == map(a -> length(first(a):2:last(a)), axes(A)),
           "Can index with StepRange and trailing colons" => 
               A -> size(A[map(a -> first(a):2:last(a), axes(A))..., :, :, :]) == (map(a -> length(first(a):2:last(a)), axes(A))..., 1, 1, 1),
           "Can index with a Vector of Int" =>  A -> begin
               i = [first(axes(A, 1)):2:last(axes(A, 1))...]
               res = A[i, ntuple(_ -> 1, ndims(A) - 1)...]
               size(res) == (length(i),)
           end,
           "Can index with a Vector of Int32" => A -> begin
               i = Int32[first(axes(A, 1)):2:last(axes(A, 1))...]
               res = A[i, ntuple(_ -> 1, ndims(A) - 1)...]
               size(res) == (length(i),)
           end,
           "Can index with a Vector of Int with trailing ones" =>  A -> begin
               i = [first(axes(A, 1)):2:last(axes(A, 1))...]
               res = A[i, ntuple(_ -> 1, ndims(A) + 1)...]
               size(res) == (length(i),)
           end,
           "Can index with a Vector of Int with trailing colons" =>  A -> begin
               i = [first(axes(A, 1)):2:last(axes(A, 1))...]
               res = A[i, ntuple(_ -> :, ndims(A) + 1)...]
               size(res) == (length(i), ntuple(i -> size(A, i + 1), ndims(A) + 1)...)
           end,
        ), 
        indexstyle = "IndexStyle returns IndexCartesian or IndexLinear" => 
            A -> IndexStyle(A) in (IndexCartesian(), IndexLinear()),
    ),
    # TODO implement all the optional conditions
    optional = (;
        logical = (
           "Can index with logical indices" =>  A -> begin
               l = [iseven(i) for i in 1:size(A, 1)]
               size(A[l, ntuple(_ -> 1, ndims(A) - 1)...]) == (count(l),)
           end,
           "Can index with logical indices and trailing ones" =>  A -> begin
               l = [iseven(i) for i in 1:size(A, 1)]
               size(A[l, ntuple(_ -> 1, ndims(A) + 1)...]) == (count(l),)
           end,
           "Can index with logical indices and trailing colons" =>  A -> begin
               l = [iseven(i) for i in 1:size(A, 1)]
               size(A[l, ntuple(_ -> :, ndims(A) + 1)...]) == (count(l), ntuple(i -> size(A, i + 1), ndims(A) + 1)...)
           end,
           "Can index with multidimensional logical indices" =>  A -> begin
               l = map(CartesianIndices(A)) do I
                   iseven(prod(Tuple(I)))
               end
               size(A[l]) == (count(l),)
           end,
           "Can index with multidimensional logical indices and trailing ones" =>  A -> begin
               l = map(CartesianIndices(A)) do I
                   iseven(prod(Tuple(I)))
               end
               size(A[l, 1, 1, 1]) == (count(l),)
           end,
           "Can index with multidimensional logical indices and trailing colons" =>  A -> begin
               l = map(CartesianIndices(A)) do I
                   iseven(prod(Tuple(I)))
               end
               size(A[l, :, :, :]) == (count(l), 1, 1, 1)
           end,
        ),
        setindex! = (
            A -> length(A) > 1 || throw(ArgumentError("Test arrays must have more than one element to test setindex!")),
            "setindex! can write the first to the last element" => 
                A -> begin
                    x1 = A[begin]; x2 = A[end]
                    A[begin] = x2
                    A[end] = x1
                    A[begin] == x2 && A[end] == x1
                end,
            "setindex! can write the first to the last element using multidimensional indices" =>
                A -> begin
                    fs = map(first, axes(A))
                    ls = map(last, axes(A))
                    x1 = A[fs...];
                    x2 = A[ls...]
                    A[fs...] = x2
                    A[ls...] = x1
                    A[fs...] == x2 && A[ls...] == x1
                end,
            "setindex! can write to all indices in eachindex(A)" => 
                A -> begin
                    v = first(A)
                    all(eachindex(A)) do i
                        A[i] = v
                        A[i] === v
                    end
                end,
            "setindex! can write to all indices in CartesianIndices(A)" => 
                A -> begin
                    v = first(A) # We have already tested writing to the first index above
                    all(CartesianIndices(A)) do i
                        A[i] = v
                        A[i] === v
                    end
                end,
        ),
        similar_type = "`similar(A)` returns an object the same type and size as `A`" => 
            A -> begin
                A1 = similar(A)
                A1 isa typeof(A) && size(A1) == size(A)
            end,
        similar_eltype = "similar(A, T::Type) returns an object the same base type as `A` with eltype of `T`" => 
            A -> begin
                A1 = similar(A, ArrayTestVal); 
                _wrappertype(A) == _wrappertype(A1) && eltype(A1) == ArrayTestVal && size(A) == size(A1)
            end,
        similar_size = "similar(A, s::NTuple{Int}) returns an object the same type as `A` with size `s`" =>
            A -> begin
                A1 = similar(A, (2, 3))
                A2 = similar(A, (4, 5))
                _wrappertype(A) == _wrappertype(A1) && size(A1) == (2, 3) && size(A2) == (4, 5)
            end,
        similar_eltype_size = "similar(A, T::Type, s::NTuple{Int}) returns an object the same type as `A` with eltype `T` and size `s`" =>
            A -> begin
                A1 = similar(A, ArrayTestVal, (2, 3))
                A2 = similar(A, ArrayTestVal, (4, 5))
                _wrappertype(A) == _wrappertype(A1) && eltype(A1) == ArrayTestVal && size(A1) == (2, 3) && size(A2) == (4, 5) 
            end,
    )
)

_wrappertype(A) = Base.typename(typeof(A)).wrapper

@interface ArrayInterface AbstractArray array_components "Base Julia AbstractArray interface"

struct InterfaceError <: Exception 
    t::Type
    name::Symbol
    num::Union{Nothing,Int}
    desc::String
    obj::Any
    e::Exception
end

function Base.showerror(io::IO, ie::InterfaceError)
    printstyled("InterfaceError: "; color=:red)
    numstring = isnothing(ie.num) ? "" : " $(ie.num)"
    println("test for $(ie.t) :$(ie.name)$(numstring)$(ie.desc) threw a $(typeof(ie.e)) \n For test object $(ie.obj):\n")
    Base.showerror(io, ie.e)
end

# Wrap objects so we don't get confused iterating
# inside the objects themselves during tests.
struct TestObjectWrapper{O}
    objects::O
end

Base.iterate(tow::TestObjectWrapper, args...) = iterate(tow.objects, args...)
Base.length(tow::TestObjectWrapper, args...) = length(tow.objects)
Base.getindex(tow::TestObjectWrapper, i::Int) = getindex(tow.objects, i)

function check_coherent_types(O::Type, obj)
    if obj isa Arguments
        coherent_types = any(T -> T <: O, fieldtypes(typeof(nt(obj))))
    else
        coherent_types = obj isa O
    end
    if !coherent_types
        throw(ArgumentError("""Each tested object must either be an instance of `$O` or an instance of `Arguments` whose field types include at least one subtype of `$O`. You provided a `$(typeof(obj))` instead. """))
    end
end
function check_coherent_types(O::Type, tow::TestObjectWrapper)
    for obj in tow
        check_coherent_types(O::Type, obj)
    end
end

"""
    test(; kw...)
    test(mod::Module; kw...)
    test(::Type; kw...)
    test(::Type{<:Interface}; kw...)
    test(::Type{<:Interface}, mod::Module; kw...)
    test(::Type{<:Interface}, type::Type, [test_objects]; kw...)

Test if an interface is implemented correctly, returning `true` or `false`.

There are a number of ways to select implementations to test:

- With no arguments, test all defined `Interface`s currenty imported.
- If a `Module` is passed, all `Interface` implementations defined in it will be tested. 
    This is probably the best option to put in package tests.
- If only an `Interface` is passed, all implementations of it are tested.
- If only a `Type` is passed, all interfaces it implements are tested.
- If both a `Module` and an `Interface` are passed, test the intersection.
    of implementations of the `Interface` for the `Module`.
- If an `Interface` and `Type` are passed, the implementation for that type will be tested.

If no interface type is passed, Interfaces.jl will find all the
interfaces available and test them.
"""
function test end
test(; kw...) = _test_module_implements(Any, nothing; kw...)
test(T::Type{<:Interface}, mod::Module; kw...) =
    _test_module_implements(Type{_check_no_options(T)}, mod; kw...)
test(mod::Module; kw...) = _test_module_implements(Any, mod; kw...)
test(T::Type{<:Interface}; kw...) =
    _test_module_implements(Type{_check_no_options(T)}, nothing; kw...)

function _check_no_options(T)
    T isa UnionAll || throw(ArgumentError("Interface options not accepted for more than one implementation"))
    return T
end
# Here we test all the `implements` methods in `methodlist` that were defined in `mod`.
# Basically we are using the `implements` method table as the global state of all
# available implementations.
function _test_module_implements(T, mod; show=true, kw...)
    # (T == Any || T isa UnionAll) || throw(ArgumentError("Interface options not accepted for more than one implementation"))
    # Get all methods for `implements(T, x)`
    methodlist = methods(Interfaces.implements, Tuple{T,Any})
    # Check that all found methods are either unrequired, or pass their tests
    results = map(methodlist) do m
        (isnothing(mod) && m.module != Interfaces) || m.module == mod || return nothing, true
        # We define this signature in the @interface macro so we know it is this consistent.
        # There may be some methods to help with these things?
        
        # Handle either Type or UnionAll for the method signature parameters
        b = m.sig isa UnionAll ? m.sig.body : m.sig

        # Skip the fallback methods
        b.parameters[2] == Type{<:Interface} && return nothing, true

        # Skip the Type versions of implements and keep the UnionAll
        t = b.parameters[2].var.ub
        t isa UnionAll || return nothing, true

        interface = t.body.name.wrapper
        implementation = b.parameters[3].var.ub
        implementation == Any && return nothing, true

        (interface, implementation), test(interface, implementation; show, kw...)
    end
    if show
        println(stdout)
        println(stdout, "Implementation summary:")
        hasprinted = false
        for (x, res) in results
            isnothing(x) && continue
            interface, implementation = x
            hasprinted = true
            print_imlements(interface, implementation, res)
        end
        hasprinted || println("\nNo implementations were found for $T and $mod")
    end
    return all(last, results)
end

function test(T::Type{<:Interface{Keys}}, O::Type, test_objects=test_objects(T, O); kw...) where Keys
    # Allow passing the keys in the abstract type
    # But get them out and put them in the `keys` keyword
    T1 = _get_type(T).name.wrapper
    objs = TestObjectWrapper(test_objects)
    # And run the tests on the parameterless type
    return _test(T1, O, objs; keys=Keys, kw...)
end
function test(T::Type{<:Interface}, O::Type, test_objects=test_objects(T, O); kw...)
    objs = TestObjectWrapper(test_objects)
    return _test(T, O, objs; kw...)
end
# Convenience method for users to test a single object
test(T::Type{<:Interface}, obj; kw...) = test(T, typeof(obj), (obj,); kw...)
# Test types for all the interfaces they implement
function test(::Type{T}; show=true, kw...) where T
    # Get every interface declaration
    methodlist = methods(Interfaces.components)
    results = map(methodlist) do m
        t = m.sig.parameters[2].var.ub
        t isa UnionAll || return true
        interface = t.body.name.wrapper
        # If T implements it, test that
        if implements(interface, T)
            interface, test(interface, T; show, kw...)
        else
            nothing, true
        end
    end
    if show
        println(stdout)
        println(stdout, "Interface summary for $T:")
        for (interface, res) in results
            isnothing(interface) && continue
            print_imlements(interface, T, res)
        end
    end
    return all(last, results)
end

function print_imlements(interface, T, res)
    printstyled(stdout, "  ", T; color=:yellow)
    print(stdout, " correctly implements ")
    printstyled(stdout, interface, ": "; color=:blue) 
    printstyled(stdout, res; color=_boolcolor(res))
    println(stdout)
end

function _test(T::Type{<:Interface}, O::Type, objs::TestObjectWrapper;
    show=true, keys=nothing
)
    O <: requiredtype(T) || throw(ArgumentError("$O is not a subtype of $(requiredtype(T))"))  
    check_coherent_types(O, objs)
    if show
        print("\nTesting ")
        printstyled(_get_type(T).name.name; color=:blue)
        print(" is implemented for ")
        printstyled(O, "\n"; color=:blue)
    end
    if isnothing(keys)
        optional = NamedTuple{optional_keys(T, O)}(components(T).optional)
        mandatory_results = _test(T, components(T).mandatory, objs)
        optional_results = _test(T, optional, objs)
        if show
            _showresults(stdout, mandatory_results, "\nMandatory components")
            if !isempty(optional_results)
                _showresults(stdout, optional_results, "\nOptional components")
            end
        end
        return all(_bool(mandatory_results)) && all(_bool(optional_results))
    else
        allcomponents = merge(components(T)...)
        optional = NamedTuple{_as_tuple(keys)}(allcomponents)
        results = _test(T, optional, objs)
        show && _showresults(stdout, results, "Specified components")
        return all(_bool(results))
    end
end

function _test(T, tests::NamedTuple{K}, objs::TestObjectWrapper) where K
    map(keys(tests), values(tests)) do k, v
        _test(T, k, v, objs)
    end |> NamedTuple{K}
end
function _test(T, name::Symbol, condition::Tuple, objs, i=nothing)
    map(condition, ntuple(identity, length(condition))) do c, i
        _test(T, name, c, objs, i)
    end
end
function _test(T, name::Symbol, condition::Tuple, objs::TestObjectWrapper, i=nothing)
    map(condition, ntuple(identity, length(condition))) do c, i
        _test(T, name, c, objs, i)
    end
end
function _test(T, name::Symbol, condition, objs::TestObjectWrapper, i=nothing)
    map(o -> _test(T, name, condition, o, i), objs.objects)
end
function _test(T, name::Symbol, condition, obj, i=nothing)
    obj_copy = deepcopy(obj)
    res = try
        f = condition isa Pair ? condition[2] : condition
        f(obj_copy)
    catch e
        desc = condition isa Pair ? string(" \"", condition[1], "\"") : ""
        rethrow(InterfaceError(T, name, i, desc, obj, e))
    end

    # Allow returning a function or tuple of functions that are tested again
    if res isa Union{Pair,Tuple,Base.Callable}
        return _test(T, name, res, obj, i)
    else
        return condition isa Pair ? condition[1] => res : res
    end
end

function _showresults(io::IO, results::NamedTuple, title::String)
    printstyled(title; color=:light_black)
    println()
    foreach(keys(results), results) do k, res
        printstyled("$k"; color=:magenta)
        print(": ")
        _showresult(io, k, res)
        println()
    end
end

_showresult(io, key, res) = show(res)
function _showresult(io, key, pair::Pair)
    desc, res = pair
    print(desc, " ")
    _showresult(io, key, res)
end
_showresult(io, key, res::Bool) = printstyled(io, res; color=_boolcolor(res))
function _showresult(io, key, res::AbstractArray)
    print(io, "[") 
    _showresult(io, key, first(res))
    for r in res[2:end]
        print(io, ", ") 
        _showresult(io, key, r) 
    end
    print(io, "]") 
end
function _showresult(io, key, res::AbstractArray{<:Pair})
    _showresult(io, key, first(first(res)) => last.(res))
end
function _showresult(io, key, res::NTuple{<:Any,Bool})
    print(io, "(") 
    _showresult(io, key, first(res))
    map(r -> (print(io, ", "); _showresult(io, key, r)), Base.tail(res))
    print(io, ")") 
end
function _showresult(io, key, res::NTuple{<:Any})
    print(io, "(") 
    _showresult(io, key, first(res))
    spacer = join([' ' for i in 1:length(string(key)) + 3])
    map(r -> (print(io, ",\n$spacer"); _showresult(io, key, r)), Base.tail(res))
    print(io, ")") 
end

_bool(xs::Union{Tuple,NamedTuple,AbstractArray}) = all(map(_bool, xs))
_bool(x::Pair) = x[2]
_bool(x::Bool) = x
_bool(x) = convert(Bool, x)

_as_tuple(x) = (x,)
_as_tuple(xs::Tuple) = xs

_get_type(obj) = _get_type(typeof(obj))
_get_type(T::Type) = T
_get_type(T::UnionAll) = _get_type(T.body)

_boolcolor(res) = res ? :green : :red

# # Advanced

#=
Here's an example of a multi-argument interface where we implement _groups_.
For mathematicians, a group is just a set of objects where you can perform `multiplication` and `inversion`, such that an element multiplied by its inverse yields a `neutral` element.

!!! warning "Warning"
    This functionality is still experimental and might evolve in the future.
    If you have feedback about it, open an issue to help us improve it!
=#

using Interfaces

# ## Definition

#=
Unlike the `AnimalInterface`, this example involves functions with more than one argument.
Such arguments need to be passed to the interface testing code, which means the interface definition must take them into account as well.

For technical reasons, we provide a type called `Arguments` that you should use for this purpose.
It behaves exactly like a `NamedTuple` but enables easier dispatch.
=#

module Group

using Interfaces

function neutral end
function multiplication end
function inversion end

@interface GroupInterface Number (
    mandatory = (;
        neutral_check = (
            "neutral stable" => a::Arguments -> neutral(typeof(a.x)) isa typeof(a.x),
        ),
        multiplication_check = (
            "multiplication stable" => a::Arguments -> multiplication(a.x, a.y) isa typeof(a.x),
        ),
        inversion_check = (
            "inversion stable" => a::Arguments -> inversion(a.x) isa typeof(a.x),
            "inversion works" => a::Arguments -> multiplication(a.x, inversion(a.x)) ≈ neutral(typeof(a.x)),
        ),
    ),
    optional = (;),
) """
A group is a set of elements with a neutral element where you can perform multiplications and inversions.

The conditions checking the interface accept an `Arguments` object with two fields named `x` and `y`.
The type of the first field `x` must be the type you wish to declare as implementing `GroupInterface`.
"""

end;

# ## Implementation

# Let's try to see if our favorite number types do indeed behave like a group.

Group.neutral(::Type{N}) where {N<:Number} = one(N)
Group.multiplication(x::Number, y::Number) = x * y
Group.inversion(x::Number) = inv(x)

# First, we check it for floating point numbers, giving a list of `Arguments` objects with the proper fields to the `test` function.

float_pairs = [Arguments(x = 2.0, y = 1.0)]
Interfaces.test(Group.GroupInterface, Float64, float_pairs)

# We can thus declare proudly

@implements Group.GroupInterface Float64 [Arguments(x = 2.0, y = 1.0)]

#=
Now we check it for integer numbers.
The reason it fails is because for an integer `x`, the inverse `1/x` is no longer an integer!
Thus integer numbers are not a multiplicative group.
=#

int_pairs = [Arguments(x = 2, y = 1)]
Interfaces.test(Group.GroupInterface, Int, int_pairs)

#=
What happens if we give an input whose field types (`Int`) are not coherent with the type we are testing (`Float64`)?
=#

try
    Interfaces.test(Group.GroupInterface, Float64, int_pairs)
catch e
    print(e.msg)
end

#=
In summary, there are two things to remember:

1. The anonymous functions in the interface conditions of `Interfaces.@interface` should accept a single object of type `Arguments` and then work with its named fields. These fields should be listed in the docstring.
2. The list of objects passed to `Interface.test` must all be of type `Arguments`, with the right named fields. At least one field must have the type you are testing.
=#

# The following tests are not part of the docs  #src

using Test  #src

@test Interfaces.test(Group.GroupInterface, Float64)  #src
@test !Interfaces.test(Group.GroupInterface, Int, int_pairs)  #src
@test_throws ArgumentError Interfaces.test(Group.GroupInterface, Float64, int_pairs)  #src

include("test_generated_docs.jl")  #src

"""
    Interface{Components}

Abstract supertype for all Interfaces.jl interfaces.

Components is an `Tuple` of `Symbol`.
"""
abstract type Interface{Components} end

"""
    optional_keys(T::Type{<:Interface}, O::Type)

Get the keys for the optional components of an [`Interface`](@ref),
as a tuple os `Symbol`.
"""
function optional_keys end
optional_keys(T::Type{<:Interface}, obj) = optional_keys(T, typeof(obj)) 
optional_keys(T::Type{<:Interface}, obj::Type) = ()
optional_keys(T::Type{<:Interface}) = keys(components(T).optional)

mandatory_keys(T::Type{<:Interface}, args...) = keys(components(T).mandatory)

"""
    test_objects(T::Type{<:Interface}, O::Type)

Get the test object(s) for type `O` and interface `T`.
"""
function test_objects end

"""
    description(::Type{<:Interface})

Returns a `String` description of an interface.
"""
function description end

"""
    components(::Type{<:Interface})

Returns the components of the interface, as a `NamedTuple` of `NamedTuple`.
"""
function components end

"""
    requiredtype(::Type{<:Interface})

Returns the supertype required for all interface implementations.
"""
function requiredtype end

"""
@interface(interfacename, components, [description])

Define an interface that can apply to types `<: Any`.

```julia
components = (
    mandatory = (
        length = x -> length(x) = prod(size(x)),
        ndims = x -> ndims(x) = length(size(x)),
    ),
    optional = (;)
)
description = "A description of the interface"

@interface MyInterface Any components description
```
"""
macro interface(interface::Symbol, type, components, description)
    quote
        @assert $type isa Type
        @assert $components isa NamedTuple{(:mandatory,:optional)}
        @assert $description isa String
        # Define the interface type (should it be concrete?)
        abstract type $interface{Components} <: $Interfaces.Interface{Components} end
        # Define the interface component methods
        $Interfaces.requiredtype(::Type{<:$interface}) = $type
        $Interfaces.components(::Type{<:$interface}) = $components
        $Interfaces.description(::Type{<:$interface}) = $description
        # Generate a docstring for the interface
        let description=$description,
            interfacesym=$(QuoteNode(interface)),
            header=$Interfaces._help_header($interface),
            extended_help=$Interfaces._extended_help($interface)
            @doc """
                $("   ") $interfacesym

            $header

            $description

            $extended_help
            """ $interface 
        end
    end |> esc
end

"""
    Arguments{names,T}

    Arguments(; kw...)
    Arguments(nt::NamedTuple)

A wrapper for a `NamedTuple`.
"""
struct Arguments{names,T}
    nt::NamedTuple{names,T}
end

Arguments(; kw...) = Arguments(values(kw))
Arguments{names}(vals) where {names} = Arguments(NamedTuple{names}(vals))

nt(a::Arguments) = getfield(a, :nt)

for f in (:length, :firstindex, :lastindex, :isempty, :keys, :values, :propertynames)
    @eval Base.$f(a::Arguments) = $f(nt(a))
end

for f in (:(==), :isequal, :<, :isless, :isapprox)
    @eval Base.$f(a1::Arguments, a2::Arguments) = $f(nt(a1), nt(a2))
end

Base.iterate(a::Arguments, iter...) = iterate(nt(a), iter...)

Base.getindex(a::Arguments, i::Union{<:Integer,Symbol}) = getindex(nt(a), i)
Base.getindex(a::Arguments, ::Colon) = a

Base.haskey(a::Arguments, key::Union{<:Integer,Symbol}) = haskey(nt(a), key)

Base.getproperty(a::Arguments, key::Symbol) = getproperty(nt(a), key)

first_field_type(::Type{Arguments{names,T}}) where {names,T} = first(fieldtypes(T))

module BaseInterfaces

using Interfaces

import Interfaces: test, test_objects, implements, description, components, requiredtype, @implements

export Interfaces

export ArrayInterface, DictInterface, IterationInterface, SetInterface

include("interfaces/iteration.jl")
include("interfaces/dict.jl")
include("interfaces/set.jl")
include("interfaces/array.jl")

include("implementations/iteration.jl")
include("implementations/dict.jl")
include("implementations/set.jl")
include("implementations/array.jl")

end

using BaseInterfaces
using Interfaces
using Test

# Test some Test objects
@implements SetInterface{(:empty,:emptymutable,:hasfastin,:intersect,:union,:sizehint!)} Test.GenericSet [Test.GenericSet(Set((1, 2)))]
@implements DictInterface Test.GenericDict [Arguments(d=Test.GenericDict(Dict(:a => 1, :b => 2)), k=:c, v=3)]

# Test all interfaces
@test Interfaces.test()

# Test all interfaaces in BaseInterfaces
@test Interfaces.test(BaseInterfaces)
@test Interfaces.test(Main)

# Or test each interface in the module individually
@test Interfaces.test(ArrayInterface, BaseInterfaces)
@test Interfaces.test(DictInterface, BaseInterfaces)
@test Interfaces.test(IterationInterface, BaseInterfaces)
@test Interfaces.test(SetInterface, BaseInterfaces)

# Now test all the interfaces implementations independent of where they are implemented
@test Interfaces.test(ArrayInterface)
@test Interfaces.test(DictInterface)
@test Interfaces.test(IterationInterface)
@test Interfaces.test(SetInterface)

@test_throws ArgumentError Interfaces.test(SetInterface{:empty})

# We can't implement LogicalIndex as it breaks the documented Base AbstractArray interface
@test_broken Interfaces.test(ArrayInterface, Base.LogicalIndex, [to_indices([1, 2, 3], ([false, true, true],))[1]])

#=
From the Base julia interface docs
https://docs.julialang.org/en/v1/manual/interfaces/

Required methods		Brief description
iterate(iter)		        Returns either a tuple of the first item and initial state or nothing if empty
iterate(iter, state)		Returns either a tuple of the next item and next state or nothing if no items remain

Important optional methods	Default definition	Brief description
IteratorSize(IterType)	        HasLength()	One of HasLength(), HasShape{N}(), IsInfinite(), or SizeUnknown() as appropriate
IteratorEltype(IterType)	HasEltype()	Either EltypeUnknown() or HasEltype() as appropriate
eltype(IterType)	        Any	        The type of the first entry of the tuple returned by iterate()
length(iter)	                (undefined)	The number of items, if known
size(iter, [dim])	        (undefined)	The number of items in each dimension, if known

Value returned by IteratorSize(IterType)	Required Methods
HasLength()	                length(iter)
HasShape{N}()	                length(iter) and size(iter, [dim])
IsInfinite()	                (none)
SizeUnknown()	                (none)

Value returned by IteratorEltype(IterType)	Required Methods
HasEltype()	eltype(IterType)
EltypeUnknown()	(none)
=#

# :size demonstrates an interface condition that instead of return a Bool,

# `Iterators.reverse` gives reverse iteration

@interface IterationInterface Any (
    # Mandatory conditions: these must be met by all types
    # that implement the interface.
    mandatory = (
        iterate = (
            "test iterator is not empty" => x -> !isempty(x),
            "iterate does not return `nothing`" => x -> !isnothing(iterate(x)),
            "iterate returns a Tuple" => x -> iterate(x) isa Tuple{<:Any,<:Any},
            "iterate returns a Tuple" => x -> iterate(x, last(iterate(x))) isa Union{Nothing,Tuple{<:Any,<:Any}},
        ),
        isiterable = x -> Base.isiterable(typeof(x)),
        eltype = x -> begin
            eltypetrait = Base.IteratorEltype(x)
            if eltypetrait isa Base.HasEltype
                return "values of `x` are `<: eltype(x)`" => x -> typeof(first(x)) <: eltype(x)
            elseif eltypetrait isa Base.EltypeUnknown
                return true
            else
                error("IteratorEltype(x) returns $eltypetrait, allowed options are `HasEltype` or `EltypeUnknown`")
            end
        end,
        size = x -> begin
            sizetrait = Base.IteratorSize(typeof(x))
            if sizetrait isa Base.HasLength
                return "`length(x)` returns an `Integer`" => x -> length(x) isa Integer
            elseif sizetrait isa Base.HasShape
                # Return more functions to test 
                return (
                    "`length(x)` returns an `Int`" => x -> length(x) isa Integer,
                    "`size(x)` returns a `Tuple` of `Integer`" => 
                        x -> size(x) isa NTuple{<:Any,<:Integer},
                    "`size(x)` matches the type parameter of `HasShape`" =>
                        x -> length(size(x)) == typeof(sizetrait).parameters[1],
                    "`length(x)` is the product of size(x)" =>
                        x -> length(x) == prod(size(x)),
                 )
            elseif sizetrait isa Base.IsInfinite
                return true
            elseif sizetrait isa Base.SizeUnknown
                return true
            else
                error("IteratorSize returns $sizetrait, allowed options are: `HasLength`, `HasLength`, `IsInfinite`, `SizeUnknown`")
            end
        end,
        in = x -> first(x) in x,
    ),
    # Optional conditions. These should be specified in the
    # interface type if an object implements them: IterationInterface{(:reverse,:indexing)}
    optional = (
        reverse = x -> collect(Iterators.reverse(x)) == reverse(collect(x)),
        # TODO: move this to collections?
        indexing = (
             "can call firstindex" => x -> firstindex(x) isa Integer,
             "can call lastindex" => x -> lastindex(x) isa Integer,
             "can call getindex" => x -> getindex(x, firstindex(x)) == first(iterate(x)),
             "getindex matches iteration order" => x -> begin
                 itr = iterate(x)
                 i = firstindex(x)
                 while !isnothing(itr)
                     getindex(x, i) == itr[1] || return false
                     itr = iterate(x, itr[2])
                     i += 1
                 end
                 return true
             end,
        ),
    )
) "An interface for Base Julia iteration"

"""
    implements(::Type{<:Interface}, obj)
    implements(::Type{<:Interface{Options}}, obj)

Returns whether an object implements an interface, as a `Bool`.

`obj` can be an be an object or a `Type`.

Options can be a `Symbol` or a `Tuple` of `Symbol` passed to the type
parameter of the `Interface`, to check if optional interfaces are
implemented by the `obj`.

Without specifying `Options`, the return value specifies that at least 
all the mandatory components of the interace are implemented.
"""
function implements end
implements(T::Type{<:Interface}, obj) = implements(T, typeof(obj))
implements(::Type{<:Interface}, obj::Type) = false

function test_objects(::Type{T}) where T<:Interface
    methodlist = methods(Interfaces.test_objects, Tuple{Type{T},Any})
    objects = Dict{Type,Any}()
    # Check that all found methods are either unrequired, or pass their tests
    for m in (methodlist)
        (m.module == Interfaces) && continue
        # We define this signature in the @interface macro so we know it is this consistent.
        # There may be some methods to help with these things?
        
        # Handle either Type or UnionAll for the method signature parameters
        b = m.sig isa UnionAll ? m.sig.body : m.sig

        # Skip the fallback methods
        b.parameters[2] == Type{<:Interface} && continue

        # Skip the Type versions of implements and keep the UnionAll
        t = b.parameters[2].var.ub
        t isa UnionAll || return nothing, true

        interface = t.body.name.wrapper
        implementation = b.parameters[3].var.ub
        implementation == Any && return continue
        objects[implementation] = test_objects(interface, implementation)
    end
    return objects
end

"""
    @implements(interface, objtype, test_objects)

Declare that an interface implements an interface, or multipleinterfaces.

The macro can only be used once per module for any one type. To define
multiple interfaces a type implements, combine them in square brackets.

# Example

Here we implement the IterationInterface for Base julia, indicating with
`(:indexing, :reverse)` that our object can be indexed and works with `Iterators.reverse`:

```julia
using BaseInterfaces, Interfaces
@implements BaseInterfaces.IterationInterface{(:indexing,:reverse)} MyObject [MyObject(1:10), MyObject(10:-1:1)]
```
"""
macro implements(interface, objtype, test_objects)
    _implements_inner(interface, objtype, test_objects)
end
function _implements_inner(interface, objtype, test_objects; show=false)
    if interface isa Expr && interface.head == :curly
        interfacetype = interface.args[1]    
        optional_keys = interface.args[2]
        # Allow a single Symbol instead of a Tuple
        if optional_keys isa QuoteNode
            optional_keys = (optional_keys.value,)
        end
    else
        interfacetype = interface
        optional_keys = ()
    end
    quote
        # Chreck that the type matches
        let objtype = $objtype, interface=$interface
            objtype <: Interfaces.requiredtype(interface) || throw(ArgumentError("$objtype is not a subtype of $(Interfaces.requiredtype(interface))"))  
        end
        # Define a `implements` trait stating that `objtype` implements `interface`
        $Interfaces.implements(::Type{<:$interfacetype}, ::Type{<:$objtype}) = true
        $Interfaces.implements(T::Type{<:$interfacetype{Options}}, O::Type{<:$objtype}) where Options = 
            $Interfaces._all_in(Options, $Interfaces.optional_keys(T, O))
        # Define which optional components the object implements
        $Interfaces.optional_keys(::Type{<:$interfacetype}, ::Type{<:$objtype}) = $optional_keys
        $Interfaces.test_objects(::Type{<:$interfacetype}, ::Type{<:$objtype}) = $test_objects
        nothing
    end |> esc
end

_all_in(items::Tuple, collection) = all(map(in(collection), items))
_all_in(item::Symbol, collection) = in(item, collection)

struct Implemented{T<:Interface} end
struct NotImplemented{T<:Interface} end

"""
    implemented_trait(T::Type{<:Interface}, obj)
    implemented_trait(T::Type{<:Interface{Option}}, obj)

Provides a single type for using interface implementation
as a trait.

Returns `Implemented{T}()` or `NotImplemented{T}()`.
"""
function implemented_trait(::Type{T}, obj) where T<:Interface
    if implements(T, obj)
        Implemented{T}()
    else
        NotImplemented{T}()
    end
end

@interface DictInterface AbstractDict ( # <: CollectionInterface
    mandatory = (;
        iterate = "AbstractDict follows the IterationInterface" => a -> Interfaces.test(IterationInterface, a.d; show=false) && first(iterate(a.d)) isa Pair,
        eltype = "eltype is a Pair" => a -> eltype(a.d) <: Pair,
        keytype = a -> keytype(a.d) == eltype(a.d).parameters[1],
        valtype = a -> valtype(a.d) == eltype(a.d).parameters[2],
        keys = a -> all(k -> k isa keytype(a.d), keys(a.d)),
        values = a -> all(v -> v isa valtype(a.d), values(a.d)),
        getindex = (
            a -> a.d[first(keys(a.d))] === first(values(a.d)),
            a -> all(k -> a.d[k] isa valtype(a.d), keys(a.d)), 
        ),
    ),
    optional = (;
        setindex! = (
            "test object `d` does not yet have test key `k`" => a -> !haskey(a.d, a.k),
            "can set key `k` to value `v`" => a -> (a.d[a.k] = a.v; a.d[a.k] == a.v),
        ),
    )
) """
`AbstractDict` interface requires Arguments, with `d = the_dict` mandatory, and
when `setindex` is needed, `k = any_valid_key_not_in_d, v = any_valid_val`
"""

# See https://github.com/JuliaLang/julia/issues/34677

# Requirements for AbstractSet subtypes:

struct SetTestVal
    x::Int
end

set_components = (;
    mandatory = (;
        isempty = "defines `isempty` and testdata is not empty" => !isempty,
        eltype = "elements eltype of set `s` are subtypes of `eltype(s)`" => s -> typeof(first(iterate(s))) <: eltype(s),
        length = "set defines length and test object has length larger than zero" => s -> length(s) isa Int && length(s) > 0,
        iteration = "follows the IterationInterface" => s -> Interfaces.test(IterationInterface, s; show=false),
        in = "`in` is true for elements in set" => s -> all(x -> in(x, s), s),
    ),
    optional = (;
        copy = "creates an identical object with the same values, that is not the same object" => 
            s -> (s1 = copy(s); s1 !== s && s1 isa typeof(s) && collect(s) == collect(s1)),
        empty = (
            "returns an empty set able to hold elements of type U" => 
                s -> (s1 = Base.empty(s); isempty(s1) && eltype(s1) == eltype(s)),
            "returns an empty set able to hold elements of arbitrary types" => 
                s -> (s1 = Base.empty(s, SetTestVal); isempty(s1) && eltype(s1) == SetTestVal),
        ),
        hasfastin = "`hasfastin` returns a `Bool`" => s -> Base.hasfastin(s) isa Bool,
        setdiff = (
            "setdiff with itself is an empty set of the same type" => s -> begin
                sd = setdiff(s, collect(s))
                sd isa typeof(s) && isempty(sd)
            end,
            "setdiff with an empty set is equal to itself" => s -> begin
                sd = setdiff(s, collect(empty(s)))
                sd isa typeof(s) && sd == s
            end,
        ),
        intersect = (
            # TODO how to cleanly get the intersect with another non-empty set
            "`intersect` of set with itself is itself" => s -> intersect(s, s) == s,
            "`intersect` of set with an empty set is an empty set" => s -> intersect(s, empty(s)) == empty(s),
        ),
        union = (
            # TODO how to cleanly get the union with another non-empty set
            "union of a set with itself equals itself" => s -> union(s, s) == s,
            "union of a set an empty set equals itself" => s -> union(s, empty(s)) == s,
        ),
        copymutable = "creates an identical mutable object with the same values, that is not the same object" => 
            s -> (s1 = Base.copymutable(s); s1 !== s && s1 isa typeof(s) && collect(s) == collect(s1)),
        emptymutable = (
            "returns an empty set able to hold elements of type U" => 
                s -> (s1 = Base.emptymutable(s); isempty(s1) && eltype(s1) == eltype(s)),
            "returns an empty set able to hold elements of arbitrary types" => 
                s -> (s1 = Base.emptymutable(s, SetTestVal); isempty(s1) && eltype(s1) == SetTestVal),
        ),
        empty! =  "empty! removes all elements from the set" => isempty ∘ empty!,
        delete! = "delete! removes element valued x of the set" => 
            s -> (x = first(iterate(s)); !in(delete!(s, x), x)),
        push! = "push! adds an element to the set" => s -> begin
            # TODO do this without delete!
            x = first(iterate(s))
            delete!(s, x)
            push!(s, x)
            in(x, s)
        end,
        # No real way to test this does anything
        sizehint! = "can set a size hint" => s -> (sizehint!(s, 10); true),
    )
)

@interface SetInterface AbstractSet set_components "The `AbstractSet` interface"

using Aqua
using Documenter
using Interfaces
using Test
using Aqua

@testset verbose = true "Interfaces.jl" begin
    # Formal tests
    doctest(Interfaces)
    @testset "Aqua" begin
        Aqua.test_all(Interfaces)
    end

    # Real tests
    @testset "Arguments" begin
        include("arguments.jl")
    end
    @testset "Basic" begin
        include("basic.jl")
    end
    @testset "Advanced" begin
        include("advanced.jl")
    end
end
